/* AccessorImpl.java */
/* Chris Jacobi, May 19, 1997 5:06 pm PDT */
/* $Id: AccessorImpl.java,v 1.3 1997/07/07 23:28:59 jacobi Exp $ */

/*
create jar file like
cd classes
jar cv0f ../MyJarFile.jar *
cd ..

compile
javac -d classes AccessorImpl.java

run
java javaserial.AccessorImpl

*/


package javaserial;

public class AccessorImpl implements javaserial.Accessor {

    static final char separatorChar = '/';
    static boolean debug = true;
    
    java.lang.String path = null;
    
    public AccessorImpl(java.lang.String path) {
        this.path = path;
    }
    
    public byte[] GetBytes(java.lang.String classname)
        throws javaserialException, xerox.ilu.IluSystemException
    {
        java.lang.String entryName = 
            classname.replace('.', separatorChar) + ".class";
        java.lang.String pathRest = this.path;
        while (pathRest != null) {
            //loop through the filenames found on the path variable
            java.lang.String thisName
                = xerox.basics.Environment.toColon(pathRest).trim();
            try {
                if (debug) {
                    System.out.println("Check [" + thisName + "]");
                }
                java.util.zip.ZipFile zf = new java.util.zip.ZipFile(thisName);
                if  (zf != null) {
                    java.util.zip.ZipEntry ze = zf.getEntry(entryName);
                    if  (ze != null) {
                        java.io.InputStream is = zf.getInputStream(ze);
                        long sizeLong = ze.getSize();
                        int sizeInt = (int) sizeLong;
                        if  ((sizeLong == (long) sizeInt) && (sizeInt > 0)) {
                            byte[] b = new byte[sizeInt];
                            int didRead = is.read(b, 0, sizeInt);
                            if (didRead == sizeInt) {
                                is.close();
                                zf.close();
                                if (debug) {
                                    System.out.println(
                                    "Successfully accessed " + classname
                                    );
                                }
                                return b;
                            }
                        }
                        is.close();
                    }
                    zf.close();
                }
            } catch (java.io.IOException e) {
                //try next entry on path
                if (debug) {
                    System.out.println(
                        "exception while accessing [" + thisName + "]: " + e
                        );
                    e.printStackTrace();
                }
            }
        pathRest = xerox.basics.Environment.fromColon(pathRest);
        }
        throw new javaserialException();
    } // GetBytes
     
    /** main is only used to debug AccessorImpl */
    public static void main(String argv[]) {
        System.out.println("Start AccessorImpl.main");
        byte[] b = null;
        AccessorImpl ai = new AccessorImpl(
            "YourJarFile.jar:MyJarFile.jar"
            );
        try {
            b = ai.GetBytes("javaserial.AccessorImpl");
        } catch (javaserialException e) {
            System.out.println("Exception " + e);
            e.printStackTrace();
        }
        System.out.println("Done AccessorImpl.main; got " + b);
    } //main
        
} //AccessorImpl


