/* JavaPickle.java */
/* Chris Jacobi, May 19, 1997 4:58 pm PDT */
/* $Id: JavaPickle.java,v 1.3 1997/05/19 23:58:51 jacobi Exp $ */


package javaserial;

public class JavaPickle extends javaserial.JavaPickleBase {
    private static final byte[] empty = new byte[0]; 
    private static final Object lock = new Object(); 
    private java.lang.Object theObject = null; //synchronized with super.bs
    public static boolean debug = true;
    
    //this makes javaserial.JavaPickleBase a custom record
    static { 
        try {
            javaserial._allJavaStubs.load();
            _theClass = 
                java.lang.Class.forName("javaserial.JavaPickle");
        } catch (java.lang.Exception e) {
            System.err.println("Exception while loading JavaPickle: " 
                + e );
        }
        System.err.println("javaserial.JavaPickle is inherently unsafe because it accesses bytecodes over the wire");
    }
    
    /** simple means to assure class is loaded */
    public static void load() {
    }
    
    /** Create a null pickle */
    public JavaPickle() {
        try {
            setObject(null, null);
        } catch (java.io.IOException e) {
            throw new java.lang.RuntimeException();
        }
    }
    
    /** Create a pickle from serializable object and class accessor */
    public JavaPickle(java.io.Serializable sob, Accessor accessor) 
            throws java.io.IOException {
        setObject(sob, accessor);
    } 
    
    /** Accesses the java object from a pickle */
    public java.lang.Object getObject() 
            throws java.io.IOException, java.lang.ClassNotFoundException  {
        if (this.theObject != null) return this.theObject;
        byte[] ba = this.bs;
        if (ba == null || ba.length == 0) return null;
        if (debug) {
            System.out.println("JavaPickle.getObject; enter");
        }
        java.io.ByteArrayInputStream in 
            = new java.io.ByteArrayInputStream(ba);
        java.io.ObjectInputStream s = new MyObjectInputStream(this, in);
        Object obj = s.readObject();
        if (debug) {
            System.out.println("JavaPickle.getObject got: " + obj);
        }
        synchronized (lock) {
            if (this.bs == ba) this.theObject = obj;
        }
        return this.theObject;
    } //getObject
    
    
    /** Defines java object refered to by pickle */
    public void setObject(java.io.Serializable sob, Accessor accessor) 
            throws java.io.IOException {
        if (sob == null) {
            synchronized (lock) {
                this.theObject = null;
                this.bs = empty;
                this.accessor = accessor;
            }
            return;
        }
        if (debug) { 
            System.out.println("JavaPickle.setObject: " + sob);
        }
        java.io.ByteArrayOutputStream bstream  
            = new java.io.ByteArrayOutputStream();
        java.io.ObjectOutput ostream 
            = new java.io.ObjectOutputStream(bstream);
        ostream.writeObject(sob);
        ostream.flush();
        byte[] ba = bstream.toByteArray();
        synchronized (lock) {
            this.theObject = sob;
            this.bs = ba;
            this.accessor = accessor;
        }
        bstream.reset();
        if (debug) {
            System.out.println("JavaPickle.setObject done");
        }
    } //setObject
    
    
} //JavaPickle


class MyObjectInputStream extends java.io.ObjectInputStream {
    
    static boolean debug = JavaPickle.debug;
    private JavaPickle container;
    private MyClassLoader loader = null;
    
    public MyObjectInputStream(JavaPickle container, java.io.InputStream s) 
            throws java.io.IOException, java.io.StreamCorruptedException {
        super(s);
        this.container = container;
    }
    
    protected java.lang.Class resolveClass(java.io.ObjectStreamClass v)
            throws java.io.IOException, java.lang.ClassNotFoundException {
        java.lang.Class clazz = null;
        String name = v.getName();
        if (debug) {
            System.out.println("MyObjectInputStream.resolveClass: " + name);
        }
        if (loader == null) {
            loader = new MyClassLoader(container.accessor);
        }
        clazz = loader.loadClass(name, true);
        return clazz;
    } //resolveClass
    
} //MyObjectInputStream


class MyClassLoader extends java.lang.ClassLoader {
    static boolean debug = JavaPickle.debug;
    Accessor accessor = null;
    java.util.Hashtable cache = new java.util.Hashtable();
    
    public MyClassLoader(Accessor accessor) {
        this.accessor = accessor;
    }
    
    private byte[] getClassData(java.lang.String name) {
        byte[] b = null;
        if (debug) {
            System.out.println("MyClassLoader.getClassData for " + name);
        }
        try {
            b = accessor.GetBytes(name);
        } catch (javaserialException e) {
            System.out.println("Failed accessing class [" + name + "]: " + e);
        }
        if (debug) {
            System.out.println("MyClassLoader.getClassData sucess");
        }
        return b;
    } //getClassData
    
    public synchronized java.lang.Class loadClass(
        java.lang.String name,
        boolean resolve)
    {
        java.lang.Class c = (java.lang.Class) cache.get(name);
        if (c == null) {
            try {
                c = findSystemClass(name);
                cache.put(name, c);
                if (resolve) resolveClass(c);
                return c;
            } catch (ClassNotFoundException e) {
            }
            byte[] data = getClassData(name);
            c = defineClass(name, data, 0, data.length);
            cache.put(name, c);
        }
        if (resolve) resolveClass(c);
        return c;
    } //loadClass
    
} //MyClassLoader
        


