/* CORBA_ObjectHelper.java */
/* Chris Jacobi, August 20, 1997 1:45 pm PDT */

/*
 * Copyright (c) 1997 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: CORBA_ObjectHelper.java,v 1.1 1997/08/20 20:47:22 jacobi Exp $ */

package xerox.ilu;

public class CORBA_ObjectHelper implements xerox.ilu.IluIOFunctions  {
    private final static java.lang.String _id = 
        "IDL:omg.com/CORBA/Object:1.0";
    
    private static xerox.ilu.IluTypeCode _tc =
        xerox.ilu.IluTypeCode.corba_objref();

    public final static java.lang.String id() {
        return _id;
    } //id 

    public final static xerox.ilu.IluTypeCode type() {
        return _tc;
    } //type 

    public static org.omg.CORBA.Object narrow(xerox.ilu.IluObject _x) {
        return (org.omg.CORBA.Object) _x;
    } //narrow 

    public static xerox.ilu.IluAny insert(org.omg.CORBA.Object _x) 
            throws xerox.ilu.IluSystemException {
        xerox.ilu.IluAny _any = new xerox.ilu.IluAny();
        xerox.ilu.IluPickle _pickle = to_pickle(_x);
        _any.setPickle(_pickle);
        return _any;
    } //insert 

    public static org.omg.CORBA.Object extract(org.omg.CORBA.Any _any) 
            throws xerox.ilu.IluSystemException {
        xerox.ilu.IluPickle _pickle = ((xerox.ilu.IluAny)_any).getPickle();
        return from_pickle(_pickle);
    } //extract 

    public static xerox.ilu.IluPickle to_pickle(org.omg.CORBA.Object _x) 
            throws xerox.ilu.IluSystemException {
        int _sz = 0;
        xerox.ilu.IluCall _call = null;
        xerox.ilu.IluPickle _pickle = new xerox.ilu.IluPickle();
        try {
            _call = _pickle.startToPickle();
            _sz = _call.szObject(_x, false, CORBA_ObjectStub.iluClass());
            _pickle.midToPickle(_call, _sz, id());
            _call.outObject(_x, false, CORBA_ObjectStub.iluClass());
        } finally {
            _pickle.endToPickle(_call);
        }
        return _pickle;
    } //to_pickle 

    public static org.omg.CORBA.Object from_pickle(xerox.ilu.IluPickle _pickle) 
            throws xerox.ilu.IluSystemException {
        org.omg.CORBA.Object _x = null;
        xerox.ilu.IluCall _call = null;
        try {
            _call = _pickle.startFromPickle(id());
            _x = (org.omg.CORBA.Object) _call.inObject(
                false, CORBA_ObjectStub.iluClass());
        } finally {
            _pickle.endFromPickle(_call);
        }
        return _x;
    } //from_pickle 

    /** Not public; implements xerox.ilu.IluIOFunctions */
    public int szFunc(
            xerox.ilu.IluCall _call, 
            java.lang.Object _x, 
            xerox.ilu.IluTypeCode _tc) 
            throws xerox.ilu.IluSystemException {
        org.omg.CORBA.Object _xx = (org.omg.CORBA.Object)_x;
        return _call.szObject(_xx, false, CORBA_ObjectStub.iluClass());
    } //szFunc 

    /** Not public; implements xerox.ilu.IluIOFunctions */
    public void outFunc(
            xerox.ilu.IluCall _call, 
            java.lang.Object _x, 
            xerox.ilu.IluTypeCode _tc) 
            throws xerox.ilu.IluSystemException {
        org.omg.CORBA.Object _xx = (org.omg.CORBA.Object)_x;
        _call.outObject(_xx, false, CORBA_ObjectStub.iluClass());
    } //outFunc 

    /** Not public; implements xerox.ilu.IluIOFunctions */
    public java.lang.Object inFunc(
            xerox.ilu.IluCall _call, 
            xerox.ilu.IluTypeCode _tc) 
            throws xerox.ilu.IluSystemException {
        return (org.omg.CORBA.Object) _call.inObject(
            false, CORBA_ObjectStub.iluClass());
    } //inFunc 

    public boolean isAFunc(Object _x, xerox.ilu.IluTypeCode _tc) {
        if (_x == null) return false;
        return (_x instanceof org.omg.CORBA.Object);
    } //isAFunc 

}//CORBA_ObjectHelper

