/* IluForEver.java */
/* Chris Jacobi, April 21, 1997 10:04 am PDT */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* 
 * $Id: IluForEver.java,v 1.3 1997/04/21 18:45:41 jacobi Exp $ 
 */
 
package xerox.ilu;

/**
 * Class to remember something and prevent it from garbage collection ... <br>
 * Not client accessible
 */
class IluForEver {
    private java.lang.Object ob = null;
    private IluForEver next = null;
    private static IluForEver root = null;
    /** Constructor: prevents clients direct use */
    private IluForEver(java.lang.Object ob) {
        this.ob = ob;
    }
    /** ob will never be garbage collected */
    public synchronized static void remember (java.lang.Object ob) {
        IluForEver fe = new IluForEver(ob);
        fe.next = root;
        root = fe;
    }
} // IluForEver