/* IluRuntimeError.java */
/* Chris Jacobi, April 21, 1997 9:57 am PDT */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: IluRuntimeError.java,v 1.5 1997/04/21 16:58:56 jacobi Exp $ */
 

package xerox.ilu;

/**
 * IluRuntimeError is a handy superclass of some exceptions.<p>
 *
 * IluRuntimeError's do not need to be declared in the throws 
 * clause (and is actually a RuntimeException, not an error).
 * This file is somewhat legacy from before IluSystemException
 * was changed to extend java.lang.RuntimeException. 
 *
 * @author Chris Jacobi
 */
public
class IluRuntimeError extends IluSystemException {
    public java.lang.Throwable causedBy = null;
    
    public IluRuntimeError() {
	super();
    }
    public IluRuntimeError(java.lang.String s) {
	super(s);
    }
    public IluRuntimeError(java.lang.String s, java.lang.Throwable causedBy) {
	super(s);
	setCause(causedBy);
    }
    public void setCause(java.lang.Throwable causedBy) {
        this.causedBy = causedBy;
    }
} //IluRuntimeError


