/* IluTrueSupport.java */
/* Chris Jacobi, November 26, 1996 10:46 am PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: IluTrueSupport.java,v 1.2 1996/11/26 18:54:45 jacobi Exp $ */
 
package xerox.ilu;

/**
 * Generic, client visible interface for objects which
 * might be used to implement true objects in Ilu.
 *
 * Finalization is restricted:
 * ==========================
 * 
 * Object is interdependent with finalized internal
 * object, which might be revived on its finalization. 
 *
 * If your Java implementation has no defined finalization 
 * order (e.g. in Sun's JDK, or, with the Boehm collector in
 * presence of circular dependencies), that means finalization 
 * may not be final after all.  
 *
 * If your Java implementation can not finalize circular
 * dependencies, then subclasses must NOT use finalization
 * and leave finalization to Ilu internal.  (No problem with 
 * either Sun's JDK, or, the Boehm collector.)
 * 
 * If an application should be considered portable we recommend 
 * avoiding finalization of classes which implement IluTrueSupport.
 */
public interface IluTrueSupport extends IluObject {
}
