/* org.omg.CORBA.Object.java */
/* Chris Jacobi, August 20, 1997 3:36 pm PDT */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: Object.java,v 1.3 1997/08/20 23:10:04 jacobi Exp $ */
 
package org.omg.CORBA;

/**
 * Generic, client visible interface for corba objects.<p>
 * This interface is only for corba compatible ilu objects
 * and should not be used by pure ilu objects.
 * The interface is not corba complete.
 * 
 * 
 * @see xerox.ilu.IluObject
 * @see org.omg.CORBA.ObjectImpl
 */
public interface Object extends xerox.ilu.IluObject {
    boolean _is_a(java.lang.String identifier);
    boolean _is_equivalent(org.omg.CORBA.Object that);
    boolean _non_existent();
    int _hash(int maximum);
    org.omg.CORBA.Object _duplicate();
    void _release();
} //Object
